def gradient_text(text, start_rgb, end_rgb, direction="horizontal"):
    start_r, start_g, start_b = start_rgb
    end_r, end_g, end_b = end_rgb

    lines = text.splitlines()
    colored_lines = []

    for i, line in enumerate(lines):
        faded = []
        length = len(line) if direction == "horizontal" else len(lines)

        for j, char in enumerate(line):
            factor = j / max(1, length - 1) if direction == "horizontal" else i / max(1, length - 1)
            r = int(start_r + (end_r - start_r) * factor)
            g = int(start_g + (end_g - start_g) * factor)
            b = int(start_b + (end_b - start_b) * factor)
            faded.append(f"\033[38;2;{r};{g};{b}m{char}\033[0m")

        colored_lines.append("".join(faded))

    return "\n".join(colored_lines)


# Defined functions
def black(text): return gradient_text(text, (0, 0, 0), (255, 255, 255))
def green(text): return gradient_text(text, (0, 255, 100), (0, 255, 255))
def blue(text): return gradient_text(text, (0, 0, 255), (0, 255, 255))
def purple(text): return gradient_text(text, (35, 0, 220), (255, 0, 220))
def yellow(text): return gradient_text(text, (0, 255, 0), (200, 255, 0))
def red(text): return gradient_text(text, (255, 250, 0), (255, 0, 0))


